// script links from background to popup/js/*
let script = document.createElement("script");
let script1 = document.createElement('script');
let script2 = document.createElement('script');
let script3 = document.createElement('script');
let script4 = document.createElement('script');

script.src = "popup/js/libs/jwt-decode.min.js";
script1.src = "popup/js/baseConstants.js";
script2.src = "popup/js/localstorage.js";
script3.src = "popup/js/cookies.js";
script4.src = "popup/js/checkUserDetails.js";

document.head.appendChild(script);
document.head.appendChild(script1);
document.head.appendChild(script2);
document.head.appendChild(script3);
document.head.appendChild(script4);

// all variable declaration ... 
let contentReadAudioBackground = new Audio();
let initialized = false;
let contentUrl = 'Reading';
let playing = false;

// receiver side of backend .............................................
chrome.runtime.onMessage.addListener( (request, sender, sendResponse)=> {
    // initialize the audio player
    if(request.messageFunction == 'initialize'){
        contentReadAudioBackground.src = request.mp3Url;
        contentReadAudioBackground.play();
        initialized = true;
        playing = true;
        contentUrl = request.contentUrl;
        sendResponse({
            success: true,
            contentUrl:  contentUrl
        });
    }
    if(request.messageFunction == 'pause'){
        contentReadAudioBackground.pause();
        playing = false;
        sendResponse({
            success: true
        });
    }
    if(request.messageFunction == 'play'){
        contentReadAudioBackground.play();
        playing = true;
        sendResponse({
            success: true
        });
    }
    if(request.messageFunction == 'audioSeekerChange'){
        contentReadAudioBackground.currentTime = request.updateTime;
        sendResponse({
            success: true
        });
    }
    if(request.messageFunction == 'checkBackgroundPlayer'){
        if(initialized){
            sendResponse({
                initialised: true
            });
        }else{
            sendResponse({
                initialised: false,
            });
        }
    }
    if(request.messageFunction == 'reset'){
        initialized=false;
        contentReadAudioBackground.pause();
        sendResponse({
            success: true
        });
    }
    if(request.messageFunction == 'status'){
        sendResponse({
            currentTime  : contentReadAudioBackground.currentTime,
            backgroundPlaying : playing,
            contentDuration  : contentReadAudioBackground.duration,
            contentUrl : contentUrl
        });
    }
});

// transmitter side of backend ........................................
contentReadAudioBackground.addEventListener("loadedmetadata" , () => {
    let message = {
        messageFunction : 'contentDuration',
        contentDuration  : contentReadAudioBackground.duration
    }
    chrome.runtime.sendMessage(message, (response) =>{
        console.log(response);
    });
});

//change playback according to audio seeker

contentReadAudioBackground.addEventListener("timeupdate" , () => {
    let message = {
        messageFunction : 'changeSeeker',
        currentTime  : contentReadAudioBackground.currentTime
    }
    chrome.runtime.sendMessage(message, (response) => {
        console.log(response);
    });
});

contentReadAudioBackground.addEventListener("ended" , () => {
    initialized = false;
    let message = {
        messageFunction : 'audioEnded',
    }
    chrome.runtime.sendMessage(message, (response) => {
        console.log(response);
    });
});

/*
*This code is handle the selected portion 
*/

function callApi(info, tab) {
    if(localStorage.getItem("email")){
        $.ajax({
            contentType: 'application/json; charset=UTF-8',
            url : baseUrl+'convert',
            dataType : 'json',
            headers : {"Authorization" : 'Bearer ' + getJwtToken()},
            data : JSON.stringify({
                "content" : info.selectionText,
                "source_url" : info.srcUrl,     
                "source_type" : "WEB_PAGE"
            }),
            type : 'POST',
            success : (response) => {
                contentReadAudioBackground.src = response.mp3;
                contentReadAudioBackground.play();
                initialized = true;
                playing = true;
                contentUrl = tab.url;
            },
            error : (err) => {
              if(err.status === 403){
                deleteCookie(xpressCueToken);
                alert("something went wrong!");
              }
              if(err.status === 500){
                alert("Sorry xpresscue can't read now! Try again later");
              }
              if(err.status === 0){
                alert("Check your internet Connection "); 
              }
              if(err.status === 402){
                alert("Check your balance");
              }
            } 
        });
    }else{
        return false;
    }
}

chrome.contextMenus.create({
    title: "Read: %s", 
    contexts:["selection"], 
    onclick: callApi
});
