let token = getJwtToken();

// PLayer clicks
$('#player').click( () => {
    window.location.href = 'loader-main.html';
});

$('#history').click( () => {
    window.location.href = 'history.html';
});

$('#settings').click( () => {
    window.location.href = 'settings.html';
});

$('#uploadsButton').click( ()=> {
    location.href = 'upload.html';
});

$('#upgradeButton').click( ()=> {
    window.open( upgradeUrl+token, '_blank');
});

$('#logout').click( () => {
    deleteCookie(xpressCueToken);
    deleteAllLocalStorage();
    message = {
        messageFunction : 'reset'
      }
      chrome.runtime.sendMessage(message, (response) =>{
        if(response.success){
          stopPlayerUI();        
        }
      });
});


$(document).ready( ()=> {
    if( !getBalanceChar() || !getEmail() || !getPlan() || !getUserName() || !getBalancePercentage()|| !getExpiryDate()){
        loading.style.display = 'block';
        $.ajax({
            contentType: 'application/json; charset=UTF-8',
            url : baseUrl+'account',
            dataType : 'json',
            headers : {"Authorization" : 'Bearer ' + token},
            type : 'GET',
            success : (response) => {
                console.log(response);
                loading.style.display = 'none';
                saveUserDataToLocalStorage(response);
                makeUserProfile();
            },
            error : (err) => {
              if(err.status == 403){
                deleteCookie(xpressCueToken);
              }
            } 
        });
    }else{
        // else take it from the localStorage
        makeUserProfile();
    }
});


function makeUserProfile () {
    //document.getElementById("balance").innerHTML = getBalanceChar();
    document.getElementById("username").innerHTML = getUserName();
    document.getElementById("expiryDate").innerHTML = getExpiryDate();
    document.getElementById("email").innerHTML = getEmail();
    document.getElementById("plan").innerHTML = getPlan();
    drawBalanceGraph();
    upgarde(); // this is here because in both above cases we can show upgrade.
}


//draw balance graph
function drawBalanceGraph(){
    let percent = Math.floor(getBalancePercentage())/100;
    var bar = new ProgressBar.Circle(balance, {
        color: '#aaa',
        // This has to be the same size as the maximum width to
        // prevent clipping
        strokeWidth: 6,
        trailWidth: 2,
        easing: 'bounce',
        duration: 1400,
        text: {
        autoStyleContainer: false
        },
        from: { color: '#3d4d91', width: 2},
        to: { color: '#3d4d91', width: 6 },
        // Set default step function for all animate calls
        step: function(state, circle) {
            circle.path.setAttribute('stroke', state.color);
            circle.path.setAttribute('stroke-width', state.width);
        
            var value = Math.round(circle.value() * 100);
            if (value === 0) {
                circle.setText('');
            } else {
                circle.setText('Balance ' +getBalanceChar().split(":")[0] + 'h:' + getBalanceChar().split(":")[1]+'m');
            }

        }
    });
    bar.text.style.fontFamily = '"Raleway", Helvetica, sans-serif';
    bar.text.style.fontSize = '1rem';
    bar.animate(percent);  // Number from 0.0 to 1.0
}

function upgarde(){
    if(checkUserIsFree()) $("#upgradeButton").show();
    else $("#upgradeButton").hide();
}

