$(document).ready( ()=> {
    let token = getCookie(xpressCueToken);
    loading.style.display = 'block';
    $.ajax({
        contentType: 'application/json; charset=UTF-8',
        url : 'https://api.readforme.io/api/v1/history',
        dataType : 'json',
        headers : {"Authorization" : 'Bearer ' +token},
        type : 'GET',
        success : (response) => {
            createHistoryItem(response.history);
            loading.style.display = 'none';
        },
        error : (err) => {
          if(err.status == 403){
            deleteCookie("fleeckMainCookie");
          }
        } 
    });
});

function createHistoryItem(historyItemArray){
    for(const [index,item] of historyItemArray.entries()){
        // creates new div
        let div = document.createElement("div");
        div.className = 'historyItem';
        div.id = 'historyItem'+index;
        document.getElementById("historyBody").appendChild(div);

        //creates a para and append to upper div
        let contentUrl = document.createElement("a");
        contentUrl.innerHTML = item.contentUrl;
        contentUrl.id = 'contentUrl'+index;
        contentUrl.className = 'contentUrl'
        contentUrl.href = item.contentUrl;
        document.getElementById('historyItem'+index).appendChild(contentUrl);

        //create a download button and append it
        let download = document.createElement("a");
        download.href = item.mp3;
        download.innerHTML = 'Download';
        download.id = 'download'+index;
        download.className = 'download';
        $("#download"+index).attr("download");
        document.getElementById('historyItem'+index).appendChild(download);
    }
}


$('#player').click( () => {
    window.location.href = 'loader-main.html';
});

$('#accountButton').click(() => {
    location.href = 'account.html';
});

$('#settings').click( () => {
    location.href = 'settings.html';
});
