/* *** WARNING *** This file contains highly complex code  Edit a your own risk. */

// variable declaration
let token = getJwtToken();
let contentUrl = 'Reading';
let mp3Url = '#';
let localDuration = 0;
// Initialzse the wave but it's blocked only it display onClick of play Button
var wave = new SiriWave({
  container: waveform,
  width: window.innerWidth,
  height: window.innerHeight * 0.3,
  cover: true,
  speed: 0.03,
  amplitude: 0.7,
  frequency: 2
});
wave.start();

// ::::::::::::::::::::::::::: STARTS HERE ( Menu items clicks and  redirect goes here ) :::::::::::::::::::::::::::::

// side menu ********************::
$('#accountButton').click( () => {
  location.href = 'account.html';
});
  
$('#history').click( ()=> {
  location.href = 'history.html';
});
  
$('#settings').click( ()=> {
  location.href = 'settings.html';
});

$('#uploadsButton').click( ()=> {
  location.href = 'upload.html';
});

$('#topupButton').click( ()=> {
  window.open(topupUrl+token, '_blank');
});

$('#upgradeButton').click( ()=> {
  window.open( upgradeUrl+token, '_blank');
});

// *******************************:
// player buttons ****************::
$('#pauseBtn').click( ()=>{
  pauseAudio();
});

$('#playBtn').click( ()=>{
  // check audio is initialized
  message = {
    messageFunction : 'checkBackgroundPlayer'
  }
  // from here main division starts one to -> load content and start from beginning and other to resume player
  // Code to read the selected text is written from line no 329 ***
   chrome.runtime.sendMessage(message, (response) => {
    if(response.initialised){
      playAudio();
    }else{
      loadContent();
    }
  });
});

$('#resetPlayer').click( ()=>{
  message = {
    messageFunction : 'reset'
  }
  chrome.runtime.sendMessage(message, (response) =>{
    if(response.success){
      stopPlayerUI();        
    }
  });
})

// ::::::::::::::::::::::::::: ENDS HERE :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


// ::::::::::::::::::::::::::: STARTS HERE ( button clicks , event loadings etc..) ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

$('document').ready( () => {
  message = {
    messageFunction : 'checkBackgroundPlayer'
  }
  // from here main division starts one to -> load content and start from beginning and other to resume player
  chrome.runtime.sendMessage(message, (response) => {
    if(response.initialised){
      resumeContent();
    }
  });
});

// ::::::::::::::::::::::::::: ENDS HERE :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


// ::::::::::::::::::::::::::: STARTS (Main Functions) :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

// road  --> to load content starts here
function loadContent(){
    loading.style.display = 'block';
    playBtn.style.display = 'none';
    // send a request to the content script to take all the body from current tab
    chrome.tabs.query({currentWindow:true, active:true}, 
      function (tabs) {
          chrome.tabs.sendMessage(tabs[0].id, {read:true}, (response) => {
            // call api from here
            callConvertApi(response);
            //set content url to send it from  initialize function written below
            contentUrl = response.contentUrl;
          });
    });
}

function callConvertApi( response ){
  $.ajax({
      contentType: 'application/json; charset=UTF-8',
      url : baseUrl+'convert',
      dataType : 'json',
      headers : {"Authorization" : 'Bearer ' +token},
      data : JSON.stringify({
          "content" : response.content,
          "source_url" : response.contentUrl,     
          "source_type" : "WEB_PAGE",
          "user_type":"CHROME_EXTN"
      }),
      type : 'POST',
      success : (response) => {
        //console.log(response);
        initializePlayer(response); // response from the api is passed to below function 
        saveUserDataToLocalStorage(response);
      },
      error : (err) => {
        //console.log(err);
        if(err.status === 403){
          deleteCookie(xpressCueToken);
        }
        if(err.status === 500){
          // call error reporting api
        }
        if(err.status === 0){
          stopPlayerUI(); 
        }
        if(err.status === 402){
          checkUserIsFree() ? $('#upgradeVoice').fadeIn(500) : $('#topupVoice').fadeIn(500);
          stopPlayerUI();
        }
      } 
  });
}

// player communications functions with background.js
function initializePlayer(response){
  mp3Url = response.mp3;
  message = {
    messageFunction : 'initialize',
    mp3Url: mp3Url,
    contentUrl : contentUrl
  }
  chrome.runtime.sendMessage(message, (response) =>{
    if(response.success){
      contentUrl= response.contentUrl;
    }
  });
}

function playAudio(){
  message = {
    messageFunction : 'play'
  }
  chrome.runtime.sendMessage(message, (response) =>{
    if(response.success){
      startPlayerUI(); 
    }
  });
}

function pauseAudio(){
  message = {
    messageFunction : 'pause'
  }
  chrome.runtime.sendMessage(message, (response) =>{
    if(response.success){
           pauseplayerUI();        
    }
  });
}

document.getElementById("audioSeeker").addEventListener("change", () => {
  let updateTime = audioSeeker.value;
  message = {
    messageFunction : 'audioSeekerChange',
    updateTime : updateTime 
  }
  chrome.runtime.sendMessage(message, (response) =>{
    if(response.success){
           console.log("updated");       
    }
  });
});


function setDurationAudioSeeker(duration){
  document.getElementById("audioSeeker").max = duration;
}

// changes seeker postion according to the player in background
function changeSeekerPosition(position){
  audioSeeker.value  = position;
}

// puts seeker in the right place while popup is clicked after audio is initialised...
function setSeekerPostion(position){
  audioSeeker.value  = position;
}

// player UI deciding functions 
function startPlayerUI(){
  document.getElementById("track").innerHTML = contentUrl;
  document.getElementById("mp3UrlDownload").href = mp3Url;
  
  wave.container.style.display = 'block';
  bar.style.display = 'none';

  loading.style.display = 'none';
  pauseBtn.style.display = 'block';
  playBtn.style.display = 'none';

  loading.style.display = 'none';
  track.style.display = 'block';

  playlistBtn.style.display = 'block';
  volumeBtn.style.display = 'block';
}

function pauseplayerUI(){
  wave.container.style.display = 'none';
  bar.style.display = 'block';

  pauseBtn.style.display = 'none';
  playBtn.style.display = 'block';
}

function setDurationTimer(duration){
  // set the top right timer duration
  s =  duration;
  var h = Math.floor(s/3600); //Get whole hours
  s -= h*3600;
  var m = Math.floor(s/60); //Get remaining minutes
  s = Math.floor(s-(m*60));
  document.getElementById("duration").innerHTML = h+":"+(m < 10 ? '0'+m : m)+":"+(s < 10 ? '0'+s : s);
}

function changeTimerUI(currentTime){
  // change time on top left 
  s =  currentTime;
  var h = Math.floor(s/3600); //Get whole hours
  s -= h*3600;
  var m = Math.floor(s/60); //Get remaining minutes
  s = Math.floor(s-(m*60));
  document.getElementById("timer").innerHTML = h+":"+(m < 10 ? '0'+m : m)+":"+(s < 10 ? '0'+s : s);
}

function stopPlayerUI(){
  wave.container.style.display = 'none';
  bar.style.display = 'block';

  pauseBtn.style.display = 'none';
  playBtn.style.display = 'block';

  track.style.display = 'none';
  loading.style.display = 'none';
} 



// :::::::::::::::::::::::::::::::::::::::::::::::::::road -->>  to resume the player
function resumeContent(){
  message = {
    messageFunction : 'status'
  }
  chrome.runtime.sendMessage(message, (response) =>{
    setDurationTimer(response.contentDuration);
    setDurationAudioSeeker(response.contentDuration);
    setSeekerPostion(response.currentTime);
    contentUrl = response.contentUrl;
    if(response.backgroundPlaying){
      startPlayerUI();
    }else{
      pauseplayerUI();
    }
  });
}


// receiver side of player ( receive any messages from the background.js)
chrome.runtime.onMessage.addListener( (request, sender, sendResponse)=> {

  // Set content duration
  if(request.messageFunction == 'contentDuration'){
    localDuration = request.contentDuration;
    setDurationTimer(localDuration);
    setDurationAudioSeeker(localDuration);
    startPlayerUI();
    sendResponse({
      success : true
    });
  }  
  
  // change playback according to audio seeker
  if(request.messageFunction == 'changeSeeker'){
    changeSeekerPosition(request.currentTime);
    changeTimerUI(request.currentTime);
    sendResponse({
      success : true
    });
  }
  if(request.messageFunction == 'audioEnded'){
    stopPlayerUI();
    sendResponse({
      success : true
    });
  }
});
