// create audio obj for assiging later in code dynamically.
const testAudio = new Audio();
let testUrl = "./voice/basic/British_Emma_Basic.mp3";
let premium = false;
let token = getJwtToken();
loading.style.display = 'block';
setHistoryState();
hideUpgrade();

// voice package add voice here and in html file settings.html ( in voice type.)
const audioPack = [
    { voiceType: "UK_EMMA_BASIC",      testUrl: './voice/basic/British_Emma_Basic.mp3',       premium: false },
    { voiceType: "UK_AMY_BASIC",       testUrl: './voice/basic/British_Amy_Basic.mp3',        premium: false },
    { voiceType: "US_JOANNA_BASIC",    testUrl: './voice/basic/US_Joanna_Basic.mp3',          premium: false },
    { voiceType: "US_JUSTIN_BASIC",    testUrl: './voice/basic/US_Justin_Basic.mp3',          premium: false },
    { voiceType: "US_MATTHEW_BASIC",   testUrl: './voice/basic/US_Matthew_Basic.mp3',         premium: false },
    { voiceType: "IN_RAVEENA_BASIC",   testUrl: './voice/basic/India_Raveena_Basic.mp3',      premium: false },
    { voiceType: "UK_EMMA_PREMIUM",    testUrl: './voice/premium/British_Emma_Premium.mp3',   premium: true },
    { voiceType: "UK_AMY_PREMIUM",     testUrl: './voice/premium/British_Amy_Premium.mp3',   premium: true },
    { voiceType: "US_JOANNA_PREMIUM",  testUrl: './voice/premium/US_Joanna_Premium.mp3',      premium: true },
    { voiceType: "US_JUSTIN_PREMIUM",  testUrl: './voice/premium/US_Justin_Premium.mp3',      premium: true },
    { voiceType: "US_MATTHEW_PREMIUM", testUrl: './voice/premium/US_Matthew_Premium.mp3',     premium: true }
];

$('document').ready( ()=> {
    loading.style.display = 'none';
    let voiceType = getVoice();
    $(`#voiceSelect option[value=${voiceType}]`).attr("selected","selected");
});

// side menu clicks ***************************************************************
$('#player').click( () => {
    window.location.href = 'loader-main.html';
});

$('#accountButton').click( () => {
    location.href = 'account.html';
});

$('#history').click( () => {
    window.location.href = 'history.html';
});

$('#uploadsButton').click( ()=> {
    location.href = 'upload.html';
});

$('#upgradeButton').click( ()=> {
    window.open( upgradeUrl+token, '_blank');
});


$('#logout').click( () => {
    deleteCookie(xpressCueToken);
    deleteAllLocalStorage();
    message = {
        messageFunction : 'reset'
      }
      chrome.runtime.sendMessage(message, (response) =>{
        if(response.success){
          stopPlayerUI();        
        }
      });
});


// Voice type selection process
//get current value of the select and store it in a local storage
$('#voiceSelect').on('change', () => {
    setDummyVoice($('#voiceSelect').find(":selected").val());
    voiceTestSetter();
    // is user is free do allow to set premium voice
    if(premium) 
        if(checkUserIsFree())   showUpgrade();
        else    hideUpgrade();
    else hideUpgrade();
});

// Used to play test audio without setting orginal audio.
$('#test').click( ()=>{
    event.preventDefault();
    setDummyVoice($('#voiceSelect').find(":selected").val());
    voiceTestSetter();
    playTestVoice();
    showStopUi();
});

$('#stop').click( ()=>{
    event.preventDefault();
    stopTestVoice();
    showTestUi();
});

// Calls api on every click on save history button
$("#historyOnOff").click( ()=>{
    setHistoryOnOff(!checkHistoryState());
    $('#historyOnOff').prop("disabled", true);
    $.ajax({
        contentType: 'application/json; charset=UTF-8',
        url : baseUrl+'settings',
        dataType : 'json',
        headers : {"Authorization" : 'Bearer ' +token},
        data : JSON.stringify({
            "save_history" : checkHistoryState()
        }),
        type : 'PATCH',
        success : (response, textStatus, xhr) => {
            console.log(response);
            if(xhr.status == 200 ){
                $('#historyOnOff').prop("disabled", false);
                saveUserDataToLocalStorage(response);
                setHistoryState();
            }
        },
        error : (err) => {
            console.log(err.status);
            if(err.status == 401){
                $('#historyOnOff').prop("disabled", false);
            } 
            if(err.status == 500){
                $('#historyOnOff').prop("disabled", false);
            }
            if(err.status == 0){
                setSuccessAlert();
                $('#historyOnOff').prop("disabled", false);
            } 
            if(err.status === 403){
                deleteCookie(xpressCueToken);
            }
        } 
    });return false;
});

// send changes to server
$('#settingsForm').submit( (e) => {
    e.preventDefault()
    document.getElementById("save").value = "Saving...";
    $.ajax({
        contentType: 'application/json; charset=UTF-8',
        url : baseUrl+'settings',
        dataType : 'json',
        headers : {"Authorization" : 'Bearer ' +token},
        data : JSON.stringify({
            "voice_type" : getDummyVoice()
        }),
        type : 'PATCH',
        success : (response, textStatus, xhr) => {
            console.log(response);
            if(xhr.status == 200 ){
                saveUserDataToLocalStorage(response);
                setSuccessAlert();
                setHistoryState();
            }
        },
        error : (err) => {
            console.log(err.status);
            if(err.status == 401){
                setSuccessAlert();
            } 
            if(err.status == 500){
                setSuccessAlert();
            }
            if(err.status == 0){
                setSuccessAlert();
            } 
            if(err.status === 403){
                deleteCookie(xpressCueToken);
            }
        } 
    });return false;
});

$(".closebtn").click( () => {
    $("#alert").fadeOut("slow");
});



// All ui componet changes ***************************************************************************

// set a success alert
function setSuccessAlert() {
    //$("#AlertMessage").html(text);
    //$("#alert").fadeIn("slow");
    document.getElementById("save").value = "save";
}

//  shows stopbutton                               
function showTestUi(){
    document.getElementById("test").style.display = 'block'
    document.getElementById("stop").style.display = 'none';   
}

// shows playbutton
function showStopUi(){
    document.getElementById("stop").style.display = 'block';
    document.getElementById("test").style.display = 'none';
}

// Sets the Save history button on/off.
function setHistoryState(){
    if(getHistoryOnOff() === "true") $("#historyOnOff").prop('checked', true);
    else $("#historyOnOff").prop('checked', false);
}

function showUpgrade(){
    $("#save").prop("disabled", true);
    $("#save").css("cursor", "not-allowed");
    $("#upgradeVoice").fadeIn(1000); 
}
function hideUpgrade(){
    $("#save").prop("disabled", false);
    $("#save").css("cursor", "pointer");
    $("#upgradeVoice").fadeOut(1000); 
}

// functionalities  ********************************************************************************

// checks current state in localstorage 
function checkHistoryState(){
    if(getHistoryOnOff() === "true") return true
    else return false;
}

// Dynamically set the audio url for playing test mp3. 
function voiceTestSetter(){
    const selectedAudio = audioPack.find(audio => audio.voiceType === getDummyVoice());
    voiceType = selectedAudio.voiceType;
    testUrl = selectedAudio.testUrl;
    premium = selectedAudio.premium;
}


// player events 
function playTestVoice(){
    testAudio.src = testUrl;
    testAudio.play();
}

function stopTestVoice(){
    testAudio.pause();
}

testAudio.addEventListener("ended", ()=> {
    showTestUi();
});

