// variable initizalization area
var  ajaxCall;
let token = getJwtToken();


// declare circle  
var bar = new ProgressBar.Circle(uploadPercent, {
        color: '#104625',
        // This has to be the same size as the maximum width to
        // prevent clipping
        strokeWidth: 12,
        trailWidth: 4,
        easing: 'easeInOut',
        duration: 1400,
        text: {
          autoStyleContainer: false
        },
        from: { color: '#104625', width: 2 },
        to: { color: '#104625', width: 8 },
        // Set default step function for all animate calls
        step: function(state, circle) {
          circle.path.setAttribute('stroke', state.color);
          circle.path.setAttribute('stroke-width', state.width);

          var value = Math.round(circle.value() * 100);
          if (value === 0) {
            circle.setText('');
          } else {
            circle.setText(" " +value + "%" +" uploaded");
          }
        }
      });
      bar.text.style.fontFamily = '"Raleway", Helvetica, sans-serif';
      bar.text.style.fontSize = '1rem';
      bar.text.style.textAlign = 'center'


// side nav button clicks and updates and logouts
$('#player').click( () => {
    location.href = 'loader-main.html';
});

$('#accountButton').click( () => {
    location.href = 'account.html';
});

$('#settings').click( ()=> {
    location.href = 'settings.html';
});

$('#logout').click( () => {
    deleteCookie(xpressCueToken);
    deleteAllLocalStorage();
    message = {
        messageFunction : 'reset'
      }
      chrome.runtime.sendMessage(message, (response) =>{
        if(response.success){
          stopPlayerUI();        
        }
      });
});

$('#upgradeButton').click( ()=> {
    window.open( upgradeUrl+token, '_blank');
});

$(document).ready( ()=> {
    // show upgrade div
    if(checkUserIsFree()) hideUpgrade();// Use this if paid users can only upload files :: showUpgrade();
    else hideUpgrade();
});

// upload file starts here
$('#fileUpload').change( ()=> {
    $('.fileContainer').fadeOut(500, ()=>{
        $('#submitButton').trigger("click");
        $('.progress').fadeIn(1000);
    });
});

// if the form is submited it calls an api
$('#uploadsForm').submit( (e) => {
    e.preventDefault();
    let formData = new FormData(document.getElementById("uploadsForm"));
    ajaxCall = $.ajax({                // you declared ajaxCall on top so that you can abprt if user changes his mind
        contentType: false,
        processData: false,
        xhr: function(){
            var xhr = new window.XMLHttpRequest();
            xhr.upload.addEventListener("progress", (e) => {
                if(e.lengthComputable){
                    bar.animate((e.loaded / e.total)); 
                }
            }, false);
            return xhr;
        },
        headers : {"Authorization" : 'Bearer ' + token},
        url : baseUrl+'upload',
        dataType : 'json',
        data : formData,
        type : 'POST',
        success : (response, textStatus, xhr) => {
            console.log(response);
            if(xhr.status == 200 ){
                $("#message").html(response.processing_status);
                $('.progress').fadeOut(1000, ()=> {
                    $('.progress-completed').fadeIn(1000);
                });
            }
        },
        error : (err) => {
            console.log(err.status);
            if(err.status == 500){
                $('.progress').fadeOut(1000, ()=>{
                    $('.server-not-responded').fadeIn(1000);
                });
            }         
            if(err.status == 403){ // invalid cookie
                deleteCookie(xpressCueToken);
            }
            if(err.status == 0){ // if ajax call aborts returns a zero
                $('.progress').fadeOut(1000, ()=>{
                    $('.fileContainer').fadeIn(1000);
                });
            }
        } 
    });
     return false;
});

$('#cancel').click(() => {
    ajaxCall.abort();
});

function showUpgrade(){
    $("#fileUpload").prop("disabled", true);
    $("#upgradeVoice").show(); 
    $("#fileUpload").css("cursor", "not-allowed");
}

function hideUpgrade(){
    $("#fileUpload").prop("disabled", false);
    $("#upgradeVoice").hide(); 
    $("#fileUpload").css("cursor", "pointer");
}